﻿Imports MediaCy.IQL.Operations
Public Module Module1
    Public Sub PrintAccumulatedHistogramValues
        If ThisApplication.ActiveImage Is Nothing Then Exit Sub
        Dim hist As McHistogram=ThisApplication.ActiveImage.Histogram
        Dim i As Integer,v As Double
        Dim sum As Double=0
        Dim vMax As Double=-1
        For i=0 To hist.BinCount-1
            'calculate sum
            v=hist.Values(i,0)
            sum+=v
            If v>vMax Then vMax=v'find max
        Next
        Dim accum As Double=0
        ThisApplication.Output.Show
        ThisApplication.Output.Clear
        ThisApplication.Output.PrintMessage (String.Format("{0}" & vbTab & "{1}" & vbTab & "{2}" & vbTab & "{3}" & vbTab & "{4}","Bin","Int.","Val","RelVal","Acc%"))
        For i=0 To hist.BinCount-1
            'Print Histogram index, Intensity value of the Bin, Value, Accumulated percentage
            v=hist.Values(i,0)
            accum+=v'calculate accumulated histogram
            ThisApplication.Output.PrintMessage (String.Format("{0}" & vbTab & "{1}" & vbTab & "{2}" & vbTab & "{3:F4}" & vbTab & "{4:F2}",i,hist.BinXValues(i),v,v/vMax,100*accum/sum))
        Next
    End Sub
End Module
